{$G+}{$X+}{$N+}{$E+}
{$B-}{$D+}{$L-}
{$M 16384,100000,655360}
Program LCARS;

{--------------------------------------------------------------

LCARS - A graphical display inspired by the Star Trek "LCARS" computer 
        interface.

This program is Freeware. It may be freely distributed without modification
as long as these notices remain intact. This program is Copyright 2003 by
Ed T. Toton III. "LCARS" is probably a trademark of Paramount or something
like that. :)


Usage:  '+main_filename+' [/A] [/C] [/T=n] [/C1=n] [/C2=n] [/C3=n] [/C4=n]

   /A    - Turn off auto-rotation of dispays (show one continuously)
   /C    - Turn off color-changing
   /S=n  - Specify the display to start with   [n = 1-7]
   /T=n  - Specify auto-rotate time in seconds [n = 10 - 600]
   /C1=n - Specify color #1 (frame color)      [n = 1 - 255]
   /C2=n - Specify color #2 (frame buttons)    [n = 1 - 255]
   /C3=n - Specify color #3 (button color)     [n = 1 - 255]
   /C4=n - Specify color #4 (button color)     [n = 1 - 255]

   Color codes can be determined by using Display #1, which
   can be activated by pressing "1" while the program is
   running. The tabs in the upper-left window next to the
   various "log" bars show the four colors in use on that
   screen. Press "1" repeatedly to see different combinations.
   For those who need more control, there is also a 6-bit
   RGB palette beginning at color 192, and a greyscale using
   color codes 16-31. Standard interface colors are 32-85.
   Colors 0-15 are standard EGA colors.


While running:

   SPACEBAR  Next display

   Q/Escape  Quit program

   1-7       Specific display

   A         Toggle auto-rotate of displays

   C         Toggle color-changing

   +/=       Increase the display-time for each screen

   -/_       Decrease the display-times

   M         Show left-over DOS memory

   TAB       Save a raw screenshot

---------------------------------------------------------------}

uses stuff,crt,graph,mygraph,svgabgi,filelib,myfile,dos,idf_unit,pcx_unit;

const
 screenshift    =-4;
 _T             =true;
 _F             =false;
 main_filename  ='LCARS';
 game_name      ='LCARS';
 version        ='0.40B';
 cnotice        =game_name+' v'+version+' Copyright 2003, Ed T. Toton III, All Rights Reserved.';
 idf_debugging  =_F;
 img_debugging  =_F;
 crash_debugging=_F;

 display_debugging=_F;
 debug_display    =6;
 max_displays     =7;

 graphics_mode  =2;
 def_update_time=1820;
 max_title      =5;


 essay:array[0..59] of string[42] =
         ('THE EXPERIMENT BEGAN VIA EXCITATION OF   ',
          'ELEMENTARY PARTICLES WITH A COHERENT     ',
          'BEAM OF ENERGY, SUCH THAT THE RESONANCE  ',
          'OF THE PARTICLES WOULD BE SYNCHRONIZED.  ',
          'AT THIS STAGE, QUANTUM ENTANGLEMENT WAS  ',
          'ACHEIVED, ALLOWING FOR SUPERLUMINAL DATA ',
          'COMMUNICATION, BY MANIPULATING THE STATE ',
          'OF ONE OF THE ENTANGLED PARTICLES. SUCH  ',
          'TELEPORTATION OF INFORMATION AND PHYSICAL',
          'STATES IS THE FIRST STEP TOWARDS A NEW   ',
          'DISCOVERY OF TELEPORTATION OF MATTER OVER',
          'GREAT DISTANCES, AND FASTER-THAN-LIGHT   ',
          'COMMUNICATIONS.                          ',
          '                                         ',
          'STARS OF EXTREMELY HIGH MASS SUFFER THE  ',
          'RISK OF EVENTUAL COLLAPSE INTO A BLACK   ',
          'HOLE. SUCH PHENOMENA ARE THEORETICALLY   ',
          'CAPABLE OF REVEALING A SO CALLED WORMHOLE',
          'WHICH IS CAPABLE OF CONVEYING MATTER OVER',
          'GREAT DISTANCES OTHERWISE UNTRAVERSABLE. ',
          '                                         ',
          'FURTHER EXAMINATION OF THE ALIEN ARTIFACT',
          'REVEALED AN ELECTROMAGNETIC HARMONIC WITH',
          'SIGNIFICANT NEUROLOGICAL, PHYSIOLOGICAL, ',
          'AND METAPHYSICAL IMPACT. COMPOSED OF MANY',
          'UNKNOWN MATERIALS OF UNUSUAL PROPERTIES, ',
          'CONTINUED ANALYSIS BECOME INCREASINGLY   ',
          'DIFFICULT, AS THE OUTER SHELL PROVED     ',
          'IMPERVIOUS TO MOST INVASIVE SCANNING     ',
          'TECHNIQUES CURRENTLY EMPLOYED. ADDITIONAL',
          'STUDY IS RECOMMENDED, HOWEVER SUGGESTED  ',
          'COURSES OF ACTION MAY BE DELAYED UNTIL   ',
          'MORE INFORMATION MAY BE GATHERED WITH    ',
          'REGARDS TO THE DEVICE''S ORIGINS.         ',
          '                                         ',
          'ADDITIONAL OBSERVATION MAY BE REQUIRED TO',
          'ASCERTAIN THE PROPERTIES OF THE MATERIAL ',
          'IN QUESTION, BUT THE TEMPORAL FLUCTUATION',
          'DETECTED IN THE LABORATORY MAY BE MORE   ',
          'THAN A SIMPLE MISCALIBRATION OF THE      ',
          'INSTRUMENTATION. OUTSIDE INTERFERANCE    ',
          'HAS NOT BEEN RULED OUT, BUT IS UNLIKELY. ',
          '                                         ',
          'BY UTILIZING A POWERFUL LOCALIZED ENERGY ',
          'FIELD, A CRYSTAL LATTICE MAY BE ALTERED  ',
          'IN SUCH A WAY AS TO ABSORB AMBIENT SUB-  ',
          'ATOMIC PARTICLES, AND THUS APPEAR TO GROW',
          'FROM NOTHINGNESS. THIS PROCESS MAY PROVE ',
          'INVALUABLE AS A RENEWABLE SOURCE OF POWER',
          'AND ENGINE COMPONENTS IN DEEP SPACE, IF  ',
          'THE PROPER PARTICLES AND CRYSTAL FORMS   ',
          'CAN BE GENERATED. ANOTHER SIGNIFICANT    ',
          'POSSIBILITY ARISING FROM THIS PRINCIPLE  ',
          'IS THAT OF INTERSTELLAR CRYSTALLINE LIFE.',
          'NO SUCH LIFE FORMS HAVE BEEN OBSERVED TO ',
          'DATE, HOWEVER STIMULATED CRYSTAL GROWTH  ',
          'VIA HIGH POWER AND OSCILLATING FREQUENCY ',
          'LASERS MAY YIELD A METHOD TO BRING LIFE  ',
          'TO OTHERWISE INANIMATE SPACE DUST.       ',
          '                                         ');
  essay_length=60;


type
 pcx_header  = record
                manufacturer,version,encoding,bitsperpixel:byte;
                xmin,ymin,xmax,ymax,hres,vres:word;
                egapal:array[0..47] of byte;
                reserved,nplanes:byte;
                bytesperline,palettetype:word;
                unused:array[0..57] of byte;
               end;
 byte_array  = array[0..65534] of byte;
 word_array  = array[0..32766] of word;
 array_pointer=^byte_array;
 screen_block= array[0..(640*16-1)] of byte;
 screen_low  = array[0..63999] of byte;
 tinystring  = string[15];
 medstring   = string[31];


var
 screen2:scr_ptr_type;
 scancode,lastscancode:byte;
 main_data      :idf;
 old_int9,old_int1C:pointer;
 color_changing,autorotate,skip,timing,quit,mouse_hidden,int9_installed,int1C_installed:boolean;
 start_display,main_timer,current_display:integer;
 main_color,fade_pal:color_type;
 update_time,cycle,last_cycle,last_load:longint;
 pcx:pcx_header;
 dc:array[0..3] of byte;
 title:array[0..max_title] of pointer;
 mypath:string;
 amp,freq:array[0..63] of integer;
 phase:array[0..63] of real;
 starx,stary,starc,stars:array[0..127] of integer;


procedure imagexy(x,y:integer; ip:pointer; c:integer);
var
 i,j,k,sx,sy:integer;
 p:^word_array;
begin
  putimage(x,y,ip^,copyput);
  p:=ip;
  sx:=p^[0];
  sy:=p^[1];
  for i:=0 to sx do
   for k:=0 to sy do
    putpixel(x+i,y+k,getpixel(x+i,y+k)*c);
end;


function cstrr(i:real):string;
var
 s1:string[255];
begin
 str(i:0:2,s1);
 cstrr:=s1;
end;


function distance(x1,y1,x2,y2:real):real;
begin
 distance:=abs(sqrt(sqr(y1-y2)+sqr(x1-x2)));
end;

function find_angle(xx,yy,tx,ty:real):real;
var
 i,j,k,v,z:integer;
 q:real;
begin
 q:=0;
    v:=abs(round(tx-xx));
    if v=0 then      {v:=0.001;}
     begin
      if (tx=xx) and (ty>yy) then q:=pi;
      if (tx=xx) and (ty<yy) then q:=0;
     end
    else
     begin
      z:=abs(round(ty-yy));
      q:=abs(arctan(z/v));
      if (tx>xx) and (ty>yy) then q:=pi/2+q;
      if (tx>xx) and (ty<yy) then q:=pi/2-q;
      if (tx<xx) and (ty<yy) then q:=pi+pi/2+q;
      if (tx<xx) and (ty>yy) then q:=pi+pi/2-q;
      if (tx=xx) and (ty>yy) then q:=pi/2;
      if (tx=xx) and (ty<yy) then q:=0;
      if (tx<xx) and (ty=yy) then q:=pi+pi/2;
      if (tx>xx) and (ty=yy) then q:=pi/2;
     end;
 find_angle:=q-(pi/2);
end;


procedure textxy(x,y:integer;s:string;col,col2:byte);
begin
 setfillstyle(1,col2);
 bar(x,y,x+length(s)*8,y+7);
 setcolor(col);
 outtextxy(x,y,s);
end;


procedure test(s:tinystring);
begin
 if crash_debugging then
    textxy(0,470,s,10,0);
end;

procedure clear_vscreen(col:byte);
label
 loop_top;
begin
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di

  mov   cx,     65535
  mov   al,     col
loop_top:
  mov   byte ptr [es:di], al
  inc   di
  loop  loop_top


  pop  es
  pop  ds
 end;

end;

procedure clear_vblock(len:word; col:byte);
label
 loop_top;
begin
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di

  mov   cx,     len
  mov   al,     col
loop_top:
  mov   byte ptr [es:di], al
  inc   di
  loop  loop_top


  pop  es
  pop  ds
 end;

end;



procedure save_raw(fn:string);
var
 i,j,k:integer;
 p:pointer;
 sb:^screen_block;
 w:^word_array;
 f:file of byte;
 r,g,b:byte;
begin
 assign(f,fn); rewrite(f);
 p:=@screen^[4]; sb:=p;
 p:=screen; w:=p;
 for i:=0 to 29 do
  begin
   getimage(0,i*16,639,i*16+15,screen^);
   for k:=0 to 16*640-1 do
    with color[screen^[4+k]] do
     begin
      r:=round(red/63*255);
      g:=round(green/63*255);
      b:=round(blue/63*255);
      write(f,r,g,b);
     end;
  end;
 close(f);
end;


procedure display_raw(fn:string);
var
 i,j,k:integer;
 p:pointer;
 sb:^screen_block;
 w:^word_array;
 f:file of screen_block;
begin
 if not exist(fn) then exit;
 assign(f,fn); reset(f);
 p:=@screen^[4]; sb:=p;
 p:=screen; w:=p;
 for i:=0 to 29 do
  begin
   read(f,sb^);
   w^[0]:=639;
   w^[1]:=15;
   putimage(0,i*16,screen^,normalput);
  end;
 close(f);
end;


procedure display_rawpanel(x,y:integer; fn:string);
type
 panel_block=array[0..(400*25-1)] of byte;
var
 i,j,k:integer;
 p:pointer;
 sb:^panel_block;
 w:^word_array;
 f:file of panel_block;
begin
 if not exist(fn) then exit;
 assign(f,fn); reset(f);
 p:=@screen^[4]; sb:=p;
 p:=screen; w:=p;
 for i:=0 to 10 do
  begin
   read(f,sb^);
   w^[0]:=399;
   w^[1]:=24;
   putimage(x,y+i*25,screen^,normalput);
  end;
 close(f);
end;


procedure display_lowres_raw(fn:string);
var
 i,j,k:integer;
 p:pointer;
 sb:^screen_low;
 w:^word_array;
 f:file of screen_low;
begin
 if not exist(fn) then exit;
 assign(f,fn); reset(f);
 p:=realscreen; sb:=p;
 read(f,sb^);
 close(f);
end;


procedure save_converted_palette(fn:string);
var
 f:text;
 i,j,k:integer;
begin
 assign(f,fn); rewrite(f);
 writeln(f,'JASC-PAL');
 writeln(f,'0100');
 writeln(f,'256');
 for i:=0 to 255 do
  with color[i] do
   begin
    writeln(f,red shl 2,' ',green shl 2,' ',blue shl 2);
   end;
 close(f);
end;


Procedure img_vmatte(x,y:integer; p:pointer; vpagesize:integer);
var
 start,upp:word;
label
 loop_top,inner_top,nevermind;
begin
 tp:=p;
 start:=y*vpagesize+x;
 upp:=vpagesize;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   nevermind
  mov  byte ptr [es:di],      al
nevermind:
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_vmatte_flip(x,y:integer; p:pointer; vpagesize:integer);
var
 start,upp:word;
 ip:array_pointer;
label
 loop_top,inner_top,nevermind;
begin
 tp:=p;
 start:=y*vpagesize+x;
 upp:=vpagesize;
 ip:=p;
 start:=start+ip^[2]*vpagesize;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  add  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   nevermind
  mov  byte ptr [es:di],      al
nevermind:
  inc  si
  inc  di

  loop inner_top
  sub  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


Procedure img_vmatte_mirror(x,y:integer; p:pointer; vpagesize:integer);
var
 start,upp:word;
label
 loop_top,inner_top,nevermind;
begin
 tp:=p;
 start:=y*vpagesize+x;
 upp:=vpagesize;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  add  di,      dx
  add  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   nevermind
  mov  byte ptr [es:di],      al
nevermind:
  inc  si
  dec  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


Procedure img_vmatte_flipmirror(x,y:integer; p:pointer; vpagesize:integer);
var
 start,upp:word;
 ip:array_pointer;
label
 loop_top,inner_top,nevermind;
begin
 tp:=p;
 start:=y*vpagesize+x;
 upp:=vpagesize;
 ip:=p;
 start:=start+ip^[2]*vpagesize+ip^[0];
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   nevermind
  mov  byte ptr [es:di],      al
nevermind:
  inc  si
  dec  di

  loop inner_top
  sub  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;



Procedure img_vscan(x1,y1,x2,y2:integer; p:pointer);
var
 start,upp,xs,ys:word;
 wp:^word_array;
label
 loop_top,inner_top,nevermind;
begin
 tp:=p; wp:=p;
 start:=y1*256+x1;
 upp:=256;
 xs:=x2-x1;
 ys:=y2-y1;
 wp^[0]:=xs;
 wp^[1]:=ys;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  mov  dx,      ys
  mov  cx,      xs
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [es:di]
  mov  byte ptr [ds:si],      al
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


procedure convert_screen(winsize,vpagesize:integer);
var
 i,j,k:integer;
 size,upp:word;
 p:pointer;
 wp:^word_array;
label
 loop_top,loop_top2,inner_top,nevermind;
begin
 p:=screen;
 tp:=p; wp:=p;
 wp^[0]:=winsize-1;
 wp^[1]:=winsize-1;
 size:=winsize;
 upp:=vpagesize-winsize;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di

  mov   dx,     size
  mov   cx,     size
  add   di,     size

  push  es
  pop   ds
  push  di
  pop   si

  add   di,     4

  { Move first line right by 4 bytes }
loop_top2:
  mov   al,     byte ptr [ds:si]
  mov   byte ptr [es:di],       al
  dec   si
  dec   di
  loop  loop_top2


  { Move all remaining lines up to concatenate }
  mov   cx,  dx
  {dec   cx}
loop_top:
  push cx

  mov  cx,      dx
  rep  movsb
  add  si,      upp

  pop cx
  loop loop_top;




  pop  es
  pop  ds
 end;
end;



procedure paste_vscreen(x,y,winsize:integer);
begin
 {--third method--}
 convert_screen(winsize,256);
 putimage(x,y,screen^,normalput);


 {--second method--}
 {img_vscan(0,0,winsize-1,winsize-1,screen2);
 putimage(x,y,screen2^,normalput);}


 {--first method below--}
 {screen^[0]:=windowsize-1;
 screen^[1]:=0;
 screen^[2]:=windowsize-1;
 screen^[3]:=0;
 putimage(x,y,screen^,normalput);}
end;



Procedure beep;
begin
 sound(1000);
 delay(10);
 sound(500);
 delay(10);
 nosound;
end;


procedure fbar(x1,y1,x2,y2,c:integer);
begin
 setfillstyle(1,c); bar(x1,y1,x2,y2);
end;


procedure box(x1,y1,x2,y2:integer);
begin
 setcolor(08); rectangle(x1,y1,x2,y2);
 setcolor(15); rectangle(x1,y1,x2-1,y2-1);
 setfillstyle(1,7); bar(x1+1,y1+1,x2-1,y2-1);
 putpixel(x1,y2,7); putpixel(x1,y2,7);
end;

procedure hole(x1,y1,x2,y2,c:integer);
begin
 setcolor(08); line(x1-1,y1-1,x1-1,y2); line(x1-1,y1-1,x2,y1-1);
 setcolor(15); line(x2+1,y1,x2+1,y2+1); line(x1,y2+1,x2+1,y2+1);
 setfillstyle(1,c); bar(x1,y1,x2,y2);
end;

{procedure vbox(x1,y1,x2,y2:integer);
begin
 v_rect(x1,y1,x2,y2,08);
 v_rect(x1,y1,x2-1,y2-1,15);
 v_bar(x1+1,y1+1,x2-1,y2-1,7);
end;

procedure vhole(x1,y1,x2,y2,c:integer);
begin
 v_bar(x1-1,y1-1,x1-1,y2,08); v_bar(x1-1,y1-1,x2,y1-1,08);
 v_bar(x2+1,y1,x2+1,y2+1,15); v_bar(x1,y2+1,x2+1,y2+1,15);
 v_bar(x1,y1,x2,y2,c);
end;}

procedure time_delay;
begin
 repeat until (main_timer<>mem[0:$46C]) or keypressed;
 main_timer:=mem[0:$46C];
end;

procedure time_wait(n:integer);
var
 i:integer;
begin
 flushkey;
 for i:=0 to n do time_delay;
end;


procedure fade_in;
var
 i,k:integer;
label abort;
begin
 black_palette;
 quit:=false;
 for i:=0 to 4 do
  begin
   for k:=0 to 255 do
    with color[k] do
     begin
      red:=round(fade_pal[k].red*i/4);
      green:=round(fade_pal[k].green*i/4);
      blue:=round(fade_pal[k].blue*i/4);
     end;
   setall(@color);
   time_delay;
   if quit or keypressed then goto abort;
  end;
 abort:
 color:=fade_pal;
 setall(@color);
 flushkey;
end;

procedure fade_out;
var
 i,k:integer;
label abort;
begin
 {set_palette;}
 fade_pal:=color;
 {color:=fade_pal;}
 quit:=false;
 for i:=10 downto 0 do
  begin
   for k:=0 to 255 do
    with color[k] do
     begin
      red:=round(fade_pal[k].red*i/10);
      green:=round(fade_pal[k].green*i/10);
      blue:=round(fade_pal[k].blue*i/10);
     end;
   setall(@color);
   time_delay;
   if quit or keypressed then goto abort;
  end;
 abort:
 black_palette;
 flushkey;
end;

procedure error_exit(s:string);
begin
 asm
  mov   ax,     00003h
  int   10h
 end;
 writeln(cnotice);
 writeln;
 writeln(s);
 writeln;
 {stop_sound;
 sound_error(0,s);}
 halt(1);
end;


function getpassword(x,y,ml,col:integer; up:boolean):string;
  var
   cp:integer;
   c:char;
   r:real;
   i:string[255];
   size:integer;
  begin
     setcolor(col);
     cp:=0;
     size:=5;
     textxy(cp*size+x,0+y,'>',col,1);
     cp:=1;
     repeat
      c:=readkey;
      if up then c:=upcase(c);
      if (c>=' ') and (c<chr(127)) then
       if cp<=ml then
        begin
         i[cp]:=c;
         textxy(cp*size+x,0+y,c,col,1);
         cp:=cp+1;
        end
       else
      else
       case ord(c) of
         8:if cp>1 then
            begin
             c:=chr(8);
             {prompt(#8#32#8);}
             cp:=cp-1;
             setfillstyle(1,1);
             bar(cp*size+x,0+y,cp*size+x+4,0+y+7);
             {setcolor(1);}
             {outtextxy(cp*size+x,0+y,'');}
            end;
        24:while cp<>1 do
            begin
             cp:=cp-1;
             setfillstyle(1,1);
             bar(cp*size+x,0+y,cp*size+x+4,0+y+7);
             {setcolor(1);
             outtextxy(cp*size+x,0+y,'');}
             {prompt(#8#32#8);}
            end;
       end;
     until (c=#13) or (c=#14);
     i[0]:=chr(cp-1);
     getpassword:=i;
  end;


procedure my_getmem(var p:pointer; l:longint);
begin
 if maxavail<l then
  error_exit('Insufficient memory ('+cstr(l)+'/'+cstr(maxavail)+'). MemFree: '+cstr(memavail))
 else
  getmem(p,l);
end;

procedure save_img(h:word; x1,y1,x2,y2:integer; var p:pointer);
var
 l,k:integer;
begin
 k:=2;
 l:=imagesize(x1,y1,x2,y2);
 write_file(h,@l,k);
 my_getmem(p,l);
 getimage(x1,y1,x2,y2,p^);
 write_file(h,p,l);
end;

procedure save_reverse(h:word; x1,y1,x2,y2:integer; var p:pointer);
var
 l,k,j,i:integer;
begin
 for i:=0 to abs(x1-x2) do
  for k:=0 to abs(y1-y2) do
   putpixel(319-i,199-abs(y1-y2)+k,getpixel(x1+i,y1+k));
 k:=abs(x1-x2); l:=abs(y1-y2);
 x1:=319-k; x2:=319;
 y1:=199-l; y2:=199;
 save_img(h,x1,y1,x2,y2,p);
end;

procedure load_img(h:word; var p:pointer);
var
 l,k:integer;
begin
 k:=2;
 read_file(h,@l,k);
 my_getmem(p,l); last_load:=l;
 read_file(h,p,l);
 if l<last_load then error_exit('Could not load image, abnormal end of file encountered.');
end;

procedure load_imgfile(fn:string; tf:boolean);
var
 i,j,k,l,x,y:integer;
 f:text;
begin
 assign(f,fn);
 reset(f);
 readln(f,x); dec(x);
 readln(f,y); dec(y);
 for i:=0 to x do
  for k:=0 to y do
   begin
    readln(f,j);
    if (j=1) and (tf) then j:=0;
    putpixel(i,k,j);
   end;
 close(f);
end;

procedure save_imgfile(x1,y1,x2,y2:integer; fn:string);
var
 i,j,k,l,xx,yy:integer;
 f:text;
begin
 assign(f,fn);
 rewrite(f);
 xx:=abs(x2-x1)+1;
 yy:=abs(y2-y1)+1;
 writeln(f,xx); dec(xx);
 writeln(f,yy); dec(yy);
 for i:=0 to xx do
  for k:=0 to yy do
   begin
    j:=getpixel(i+x1,k+y1);
    writeln(f,j);
   end;
 close(f);
end;

procedure load_scn(fn:string);
var
 h,l:word;
begin
 if not exist(fn) then error_exit('Cannot find "'+fn+'"!');
 open_filein(h,fn);
 l:=00768; read_long(h,@color,l);
 l:=64000; read_long(h,ptr($A000,0),l);
 close_file(h);
 {no_pal_change:=true;
 setall(@color);
 no_pal_change:=false;}
end;

procedure load_pcx(fn:string);
var
 h,l:word;
 i,j,k,linelen:integer;
 b,c:byte;
begin
 open_filein(h,fn);
 l:=sizeof(pcx); read_long(h,@pcx,l);
 k:=0; linelen:=0;
 with pcx do
 while (k<=ymax) do
  begin
   i:=1; read_file(h,@b,i);
   if b>=192 then
    begin
     i:=1; read_file(h,@c,i);
     a_bar(linelen,k,linelen+b-193,k,realscreen,c);
     linelen:=linelen+b-192;
    end
   else
    begin
     putpixel(linelen,k,b);
     inc(linelen);
    end;
   if linelen>xmax then begin linelen:=0; inc(k); end;
  end;
 textxy(0,190,cstr(getpixel(0,0)),10,1);
 color:=main_color; setall(@color);
 close_file(h);
end;

procedure pcx_fix(x1,y1,x2,y2:integer);
var
 x,y,i,j,k:integer;
begin
 for y:=y1 to y2 do
  for x:=x1 to x2 do
   begin
    j:=getpixel(x,y);
    with color[j] do
     if (red<=2) and (blue<=2) and (green<=2) then
      putpixel(x,y,0);
   end;
end;



procedure shutdown;
begin
 {remove_keyhandler;
 remove_soundint;}
 nosound;
 flushkey;
 cleardevice;
 color:=main_color;
 setall(@color);
 closegraph;
 close_idf(main_data);
 writeln(cnotice);
 writeln;
 flushkey;
 halt;
end;


procedure modify_palette;
var
 i,j,k,l:integer;
begin
 for i:=16 to 255 do
  with color[i] do begin
   red:=0; green:=0; blue:=0; end;
 for i:=0 to 15 do
  with color[016+i] do begin {complete greyscale}
    red:=round(i/15*63); green:=round(i/15*63); blue:=round(i/15*63); end;

 with color[32] do begin red:=38; green:=38; blue:=63; end;
 with color[33] do begin red:=38; green:=63; blue:=38; end;
 with color[34] do begin red:=38; green:=63; blue:=63; end;
 with color[35] do begin red:=63; green:=38; blue:=38; end;
 with color[36] do begin red:=63; green:=38; blue:=63; end;
 with color[37] do begin red:=63; green:=63; blue:=38; end;

 with color[38] do begin red:=38; green:=38; blue:=50; end;
 with color[39] do begin red:=38; green:=50; blue:=38; end;
 with color[40] do begin red:=38; green:=50; blue:=50; end;
 with color[41] do begin red:=50; green:=38; blue:=38; end;
 with color[42] do begin red:=50; green:=38; blue:=50; end;
 with color[43] do begin red:=50; green:=50; blue:=38; end;

 with color[44] do begin red:=25; green:=25; blue:=50; end;
 with color[45] do begin red:=25; green:=50; blue:=25; end;
 with color[46] do begin red:=50; green:=25; blue:=25; end;
 with color[47] do begin red:=25; green:=50; blue:=50; end;
 with color[48] do begin red:=50; green:=25; blue:=50; end;
 with color[49] do begin red:=50; green:=50; blue:=25; end;

 with color[50] do begin red:=50; green:=50; blue:=60; end;
 with color[51] do begin red:=50; green:=60; blue:=50; end;
 with color[52] do begin red:=60; green:=50; blue:=50; end;
 with color[53] do begin red:=50; green:=60; blue:=60; end;
 with color[54] do begin red:=60; green:=50; blue:=60; end;
 with color[55] do begin red:=60; green:=60; blue:=50; end;

 with color[56] do begin red:=00; green:=38; blue:=63; end;
 with color[57] do begin red:=00; green:=63; blue:=38; end;
 with color[58] do begin red:=38; green:=63; blue:=00; end;
 with color[59] do begin red:=63; green:=38; blue:=00; end;
 with color[60] do begin red:=55; green:=16; blue:=24; end;
 with color[61] do begin red:=38; green:=00; blue:=63; end;

 with color[62] do begin red:=25; green:=38; blue:=63; end;
 with color[63] do begin red:=25; green:=63; blue:=38; end;
 with color[64] do begin red:=38; green:=63; blue:=25; end;
 with color[65] do begin red:=63; green:=38; blue:=25; end;
 with color[66] do begin red:=63; green:=25; blue:=32; end;
 with color[67] do begin red:=38; green:=25; blue:=63; end;

 with color[68] do begin red:=00; green:=38; blue:=50; end;
 with color[69] do begin red:=00; green:=50; blue:=38; end;
 with color[70] do begin red:=38; green:=50; blue:=00; end;
 with color[71] do begin red:=50; green:=38; blue:=00; end;
 with color[72] do begin red:=50; green:=00; blue:=38; end;
 with color[73] do begin red:=38; green:=00; blue:=50; end;

 with color[74] do begin red:=25; green:=38; blue:=50; end;
 with color[75] do begin red:=25; green:=50; blue:=38; end;
 with color[76] do begin red:=38; green:=50; blue:=25; end;
 with color[77] do begin red:=50; green:=38; blue:=25; end;
 with color[78] do begin red:=50; green:=25; blue:=38; end;
 with color[79] do begin red:=38; green:=25; blue:=50; end;

 with color[80] do begin red:=40; green:=45; blue:=50; end;
 with color[81] do begin red:=40; green:=50; blue:=45; end;
 with color[82] do begin red:=45; green:=50; blue:=40; end;
 with color[83] do begin red:=50; green:=45; blue:=40; end;
 with color[84] do begin red:=50; green:=40; blue:=45; end;
 with color[85] do begin red:=45; green:=40; blue:=50; end;

 for i:=0 to 63 do
  with color[192+i] do
   begin
    red:=((i shr 4) and 3)*21;
    green:=((i shr 2) and 3)*21;
    blue:=(i and 3)*21;
   end;

 with color[0] do
  begin red:=0; green:=0; blue:=0; end;
 with color[1] do
  begin red:=63; green:=63; blue:=63; end;


 for i:=0 to 5 do
  with color[i+2] do
    begin
     red:=63;
     green:=round(((i+1)/6)*63);
     blue:=round(((i+1)/6)*63);
    end;

 for i:=0 to 7 do
  begin
   with color[8+i] do
    begin
     red:=round(((i+1)/8)*63);
     green:=0;
     blue:=0;
    end;
   with color[88+i] do
    begin
     red:=63;
     green:=round(((i+1)/8)*63);
     blue:=0;
    end;
   with color[96+i] do
    begin
     red:=0;
     green:=0;
     blue:=round(((i+1)/8)*63);
    end;
   with color[104+i] do
    begin
     red:=round(((i+1)/8)*63);
     green:=round(((i+1)/8)*63);
     blue:=63;
    end;
   with color[112+i] do
    begin
     red:=round((i/15)*63);
     green:=round((i/15)*63);
     blue:=round(((i+8)/15)*63);
    end;
   with color[120+i] do
    begin
     red:=63;
     green:=63;
     blue:=round(((i+1)/8)*63);
    end;
  end;
end;



procedure load_images;
var
 i,j,k,x,y,xx,yy:integer;
 l:longint;
 w,h:word;
begin
 flushkey;

 {--initialize pointers--}
 for i:=0 to max_title do
  title[i]:=nil;

 if img_debugging then
  begin
   color:=main_color; setall(@color);
   {load_palette('default,pal');}
   open_fileout(h,mypath+main_filename+'.IMG');

   {-Logos-}
{   load_scn('SMALLOGO.SCN');
   save_img(h,0,0,74,43,logo[0]);
   for i:=0 to 79 do
    for j:=0 to 49 do
     putpixel(i shr 1,j shr 1,getpixel(i,j));
   save_img(h,0,0,36,21,logo[1]);
   load_scn('me.scn');
   save_img(h,0,0,74,43,logo[2]);}

   display_lowres_raw('lcars02.raw');
   save_img(h,000,000,230,028,title[0]);
   save_img(h,000,028,220,057,title[1]);
   save_img(h,000,058,231,088,title[2]);
   save_img(h,000,088,231,118,title[3]);
   save_img(h,000,118,231,148,title[4]);
   save_img(h,000,148,231,178,title[5]);

{   color:=main_color; setall(@color);
   readkey;}

   close_file(h);
  end
 else
  begin
   open_filein(h,mypath+main_filename+'.IMG');
{   for j:=0 to 2 do
    load_img(h,logo[j]);}

   for i:=0 to max_title do
    load_img(h,title[i]);

   close_file(h);
  end;
 color:=main_color; setall(@color);
end;


procedure choose_colors;
var
 i,j,k,l:integer;
begin
 for i:=0 to 3 do
  dc[i]:=random(54)+32;

 if (random(5)>0) then
  begin
   dc[1]:=dc[0]+(random(9)*6);
   if dc[1] > 85 then dc[1]:=dc[1]-54;
   if dc[1] > 85 then dc[1]:=dc[1]-54;
   if (dc[1]<32) or (dc[1]>85) then dc[1]:=random(54)+32;
  end;
 if (random(5)>0) then
  begin
   dc[3]:=dc[0]+(random(9)*6);
   if dc[3] > 85 then dc[3]:=dc[3]-54;
   if dc[3] > 85 then dc[3]:=dc[3]-54;
   if (dc[3]<32) or (dc[3]>85) then dc[3]:=random(54)+32;
  end;
end;

procedure init;
var
 i,j,k,l:integer;
 c:char;
 s:string;
 p:pointer;
 scrn:scr_ptr_type;
 unknown:boolean;
begin
   writeln;
   writeln(cnotice);
   writeln;
   write('Loading...');
 clear_vscreen(0);
 randomize;
 quit:=false; cycle:=0;
 int9_installed:=false;
 int1C_installed:=false;
 timing:=true;
 {new(screen2);}
 {set_fontseg(seg(screen^));}

 mypath:=path(paramstr(0));

 color_changing:=true;
 choose_colors;
 update_time:=def_update_time;
 autorotate:=true;
 if display_debugging then start_display:=debug_display
    else start_display:=0;
 current_display:=0;

 unknown:=false;
 i:=0;
 writeln(mypath); {readkey;}
 writeln;
 if paramcount>0 then
  while (i<paramcount) do
   begin
    inc(i);
    s:=ucase(paramstr(i));
    btrim(s);
    if s[1] in ['/','\','-'] then s:=rstr(s,length(s)-1);
    if (s='A') then autorotate:=false
     else if (s='C') then color_changing:=false
     else if (lstr(s,2)='T=') then update_time:=round(value(rstr(s,length(s)-2))*18.2)
     else if (lstr(s,2)='S=') then start_display:=value(rstr(s,length(s)-2))
     else if (lstr(s,3)='C1=') then dc[0]:=value(rstr(s,length(s)-3))
     else if (lstr(s,3)='C2=') then dc[1]:=value(rstr(s,length(s)-3))
     else if (lstr(s,3)='C3=') then dc[2]:=value(rstr(s,length(s)-3))
     else if (lstr(s,3)='C4=') then dc[3]:=value(rstr(s,length(s)-3))
     else if (s[1]='?') then
       begin
         writeln;
         writeln('Usage:  '+main_filename+' [/A] [/C] [/T=n] [/C1=n] [/C2=n] [/C3=n] [/C4=n]');
         writeln;
         writeln('   /A    - Turn off auto-rotation of dispays (show one continuously)');
         writeln('   /C    - Turn off color-changing');
         writeln('   /S=n  - Specify the display to start with   [n = 1-'+cstr(max_displays)+']');
         writeln('   /T=n  - Specify auto-rotate time in seconds [n = 10 - 600]');
         writeln('   /C1=n - Specify color #1 (frame color)      [n = 1 - 255]');
         writeln('   /C2=n - Specify color #2 (frame buttons)    [n = 1 - 255]');
         writeln('   /C3=n - Specify color #3 (button color)     [n = 1 - 255]');
         writeln('   /C4=n - Specify color #4 (button color)     [n = 1 - 255]');
         writeln;
         writeln('   Color codes can be determined by using Display #1, which');
         writeln('   can be activated by pressing "1" while the program is');
         writeln('   running. The tabs in the upper-left window next to the');
         writeln('   various "log" bars show the four colors in use on that');
         writeln('   screen. Press "1" repeatedly to see different combinations.');
         writeln('   For those who need more control, there is also a 6-bit');
         writeln('   RGB palette beginning at color 192, and a greyscale using');
         writeln('   color codes 16-31. Standard interface colors are 32-85.');
         writeln;
         halt;
       end
     else begin writeln('Unknown parameter: "'+s+'". Run "'+main_filename+' /?" for help.'); unknown:=true; end;
   end;
 if update_time>182*60 then update_time:=182*60;
 if update_time<182    then update_time:=182;
 if start_display<1 then start_display:=1;
 if start_display>max_displays then start_display:=max_displays;
 for i:=0 to 3 do
  begin
   if dc[i]<1 then dc[i]:=1;
   if dc[i]>255 then dc[i]:=255;
  end;
 if unknown then halt;

  {--begin loading--}

   if idf_debugging then new_idf(main_data,mypath+main_filename+'.IDF',256)
                    else open_idf(main_data,mypath+main_filename+'.IDF');
   if idf_error<>0 then
      error_exit('Error opening file "'+mypath+main_filename+'.IDF"!');


   if img_debugging then
    begin
     graphitV;
    end
   else
    begin
     vga_graph_mode:=graphics_mode;
     graphitV;
    end;

   if idf_debugging then
     begin load_palette(mypath+'NORMAL.PAL');
           modify_palette;
           save_palette(mypath+'DEFAULT.PAL');
           save_converted_palette(mypath+main_filename+'.PAL');
           main_color:=color;
           write_idf(main_data,'DEFAULT.PAL',@main_color,768);
{           load_font(mypath+'MYFONT.FNT'); (*--DO NOT CHANGE--*)
           load_font(mypath+'SMFONT2.FNT'); (*--DO NOT CHANGE--*)
           load_font(mypath+'TFONT2.FNT');  (*--DO NOT CHANGE--*)
           load_font(mypath+'BOLD.FNT');
           load_font(mypath+'FUTURE.FNT');
           load_font(mypath+'COMPUTER.FNT');
           for i:=1 to num_fonts do
               write_idf(main_data,'FONT'+cstr(i)+'.FNT',font[i],sizeof(font_rec));}
           end
     else begin
           read_idf (main_data,'DEFAULT.PAL',@main_color,768);
{           num_fonts:=6;
           for i:=1 to num_fonts do
             new(font[i]);
           for i:=1 to num_fonts do
             read_idf(main_data,'FONT'+cstr(i)+'.FNT',font[i],sizeof(font_rec));}
           end;
   cleardevice;
   color:=main_color; setall(@color);
{   if not img_debugging then
     display_raw(mypath+main_filename+'.WEL');}

   {--Load Data--}
   load_images;


   if img_debugging then
    begin
     closegraph;
     vga_graph_mode:=graphics_mode;
     graphitV;
     color:=main_color; setall(@color);
{     display_raw(mypath+main_filename+'.WEL');}
    end;
{   install_soundint;}


{   textxy(208,454,'Press any key to continue...',11,9);
   flushkey; readkey;}

end;


procedure button_cboth(x,y,lx,ly:integer; s:medstring; c:integer);
begin
 setfillstyle(1,c);
 setcolor(c);
 fillellipse(x+ly,y+ly,ly,ly);
 fillellipse(x+ly+lx,y+ly,ly,ly);
 bar(x+ly,y,x+ly+lx,y+ly*2);
 textxy(x+ly+lx-(length(s)*8),y+ly*2-8,s,0,c);
end;


procedure button_cleft(x,y,lx,ly:integer; s:medstring; c:integer);
begin
 setfillstyle(1,c);
 setcolor(c);
 fillellipse(x+ly,y+ly,ly,ly);
 bar(x+ly,y,x+ly+lx,y+ly*2);
 textxy(x+ly+lx-(length(s)*8)-2,y+ly*2-8,s,0,c);
end;

procedure button_cright(x,y,lx,ly:integer; s:medstring; c:integer);
begin
 setfillstyle(1,c);
 setcolor(c);
 fillellipse(x+lx,y+ly,ly,ly);
 bar(x,y,x+lx,y+ly*2);
 textxy(x+lx-(length(s)*8),y+ly*2-8,s,0,c);
end;


procedure button_dboth(x,y,lx,ly:integer; s:medstring; c,t:integer);
begin
 setfillstyle(1,c);
 setcolor(c);
 fillellipse(x+ly,y+ly,ly,ly);
 fillellipse(x+ly+lx,y+ly,ly,ly);
 bar(x+ly,y,x+ly+lx,y+ly*2);
 setfillstyle(1,0);
 bar(x+ly+1,y,x+ly+t,y+ly*2);
 bar(x+ly+lx-1,y,x+ly+lx-t,y+ly*2);
 textxy(x+ly+lx-(length(s)*8)-4,y+ly*2-8,s,0,c);
end;

procedure button_dleft(x,y,lx,ly:integer; s:medstring; c,t:integer);
begin
 setfillstyle(1,c);
 setcolor(c);
 fillellipse(x+ly,y+ly,ly,ly);
 bar(x+ly,y,x+ly+lx,y+ly*2);
 setfillstyle(1,0);
 bar(x+ly+1,y,x+ly+t,y+ly*2);
 textxy(x+ly+lx-(length(s)*8)-2,y+ly*2-8,s,0,c);
end;

procedure button_dright(x,y,lx,ly:integer; s:medstring; c,t:integer);
begin
 setfillstyle(1,c);
 setcolor(c);
 fillellipse(x+lx,y+ly,ly,ly);
 bar(x,y,x+lx,y+ly*2);
 setfillstyle(1,0);
 bar(x+lx-1,y,x+lx-t,y+ly*2);
 textxy(x+lx-(length(s)*8)-4,y+ly*2-8,s,0,c);
end;


procedure button_plain(x,y,lx,ly:integer; s:medstring; c:integer);
begin
 setfillstyle(1,c);
 setcolor(c);
 bar(x,y,x+lx,y+ly*2);
 textxy(x+lx-(length(s)*8)-2,y+ly*2-8,s,0,c);
end;



function rand_label:medstring;
var
 s:medstring;
begin
 case random(10) of
  0..4:s:=hex(random(65535));
  else case random(100) of
         00:s:='ALERT';
         01:s:='ACCESS';
         02:s:='SCAN';
         03:s:='XFER';
         04:s:='OPEN';
         05:s:='CLOSE';
         06:s:='SET';
         07:s:='COMMIT';
         08:s:='INVERT';
         09:s:='SELECT';
         10:s:='CLEAR';
         11:s:='STORE';
         12:s:='MOVE';
         13:s:='DUMP';
         14:s:='DELETE';
         15:s:='ERASE';
         16:s:='ENTER';
         17:s:='EXIT';
         18:s:='BACK';
         19:s:='NEXT';
         20:s:='PREV';
         21:s:='SKIP';
         22:s:='ABORT';
         23:s:='RETRY';
         24:s:='UNDO';
         25:s:='FAIL';
         26:s:='EDIT';
         27:s:='REMOVE';
         28:s:='TEMP';
         29:s:='RENAME';
         30:s:='UPLOAD';
         31:s:='UPLINK';
         32:s:='DROP';
         33:s:='UNLINK';
         34:s:='TRACK';
         35:s:='START';
         36:s:='ACCEPT';
         37:s:='DENY';
         38:s:='TRUE';
         39:s:='FALSE';
         40:s:='STOP';
         41:s:='COMM';
         42:s:='WARP';
         43:s:='TARGET';
         44:s:='ENGINE';
         45:s:='POWER';
         46:s:='MODE';
         47:s:='WEAPON';
         48:s:='ZOOM +';
         49:s:='ZOOM -';
         50:s:='FORE';
         51:s:='AFT';
         52:s:='LCARS';
         53:s:='HELP';
         54:s:='+';
         55:s:='-';
         56:s:='CANCEL';
         57:s:='HALT';
         58:s:='NEW';
         59:s:='BEGIN';
         60:s:='END';
         61:s:='ZOOM';
         62:s:='STAT';
         63:s:='MEM';
         64:s:='INPUT';
         65:s:='OUTPUT';
         66:s:='ERROR';
         67:s:='ALLOW';
         68:s:='PERMIT';
         69:s:='GO';
         70:s:='LAUNCH';
         71:s:='THRUST';
         72:s:='FIRE';
         73:s:='REV';
         74:s:='SEP';
         75:s:='COPY';
         76:s:='SAVE';
         77:s:='QUIT';
         78:s:='TERM';
         79:s:='UP';
         80:s:='DOWN';
         81:s:='LEFT';
         82:s:='RIGHT';
         83:s:='COM';
         84:s:='DATA';
         85:s:='INFO';
         86:s:='WIERD';
         87:s:='ODD';
         88:s:='EVEN';
         89:s:='CRASH';
         90:s:='WARN';
         91:s:='ARG';
         92:s:='BLINK';
         93:s:='ZEN';
         94:s:='FROM';
         95:s:='TO';
         96:s:='ARC';
         97:s:='SINE';
         98:s:='COSINE';
         99:s:='PI';
       end;
 end;
 rand_label:=s;
end;

function rand_col(min,max:integer):integer;
 var
  j,k:integer;
begin
 j:=random(max-min+1)+min;
 k:=dc[j];
 if random(20)=0 then
   k:=128+16*j+random(16);
 if random(5)=0 then
   k:=140+16*j+random(4);
 rand_col:=k;
end;


function rand_box(min,max:integer):integer;
 var
  j,k:integer;
begin
 j:=random(max-min+1)+min;
 k:=dc[j];
 if random(15)=0 then
   k:=128+(16*j)+random(12);
 rand_box:=k;
end;


function rand_flash(min,max:integer):integer;
 var
  j,k:integer;
begin
 j:=random(max-min+1)+min;
 k:=dc[j];
 if random(3)=0 then
   k:=128+(16*j)+random(12);
 rand_flash:=k;
end;

procedure show_status(s:string);
var
 x,y,j,k,i,l:integer;
begin
 l:=length(s)*8;
 x:=315-(l shr 1);
 y:=236;
 x:=0; y:=0;
 getimage(x,y,x+l+8,y+8,screen^);
 fbar(x,y,x+l+8,y+8,0);
 textxy(x+4,y+1,s,1,0);
 for i:=0 to 30 do
  begin
   repeat until (main_timer<>mem[0:$46C]) or keypressed;
   main_timer:=mem[0:$46C];
  end;
 {flushkey;}
 putimage(x,y,screen^,copyput);
end;


procedure update_palette;
var
 i,j,k,l:integer;
begin
 for l:=0 to 3 do
  begin
   for i:=0 to 11 do
    begin
     k:=cycle mod 12;
     j:=k+i; j:=j mod 12;
     color[128+j+(l*16)].red  := round(color[dc[l]].red/11*i);
     color[128+j+(l*16)].green:= round(color[dc[l]].green/11*i);
     color[128+j+(l*16)].blue := round(color[dc[l]].blue/11*i);
    end;
   for i:=0 to 3 do
    if random(15)=0 then
     begin
      if random(2)=0 then
        with color[140+(l shl 4)+i] do begin red:=0; green:=0; blue:=0; end
      else
        color[140+(l shl 4)+i]:=color[dc[l]];
     end;
  end;
 setpal(@color,128,64);
end;

procedure myellipse(x,y,xr,yr,col:integer);
begin
  setfillstyle(1,col); setcolor(col);
  fillellipse(x,y,xr,yr);
end;


procedure flashy_number(x,y:integer);
var l:integer;
begin
  l:=rand_flash(2,3);
  textxy(x,y,addrear(cstr(random(65535)*random(11)),8),l,0);
  setcolor(l);
  setfillstyle(1,l);
  fillellipse(x+65,y+3,3,3);
end;


procedure corner_curve(x,y:integer; invert:boolean);
begin
 if invert then
  begin
        {lower-left border}
        {setfillstyle(1,dc[0]);
        setcolor(dc[0]);
        fbar(x,y,x+60,y+45,dc[0]);
        setcolor(dc[0]);
        fillellipse(x+60,y+45,60,40);
        fbar(x+60,y+65,x+138,y+85,dc[0]);
        setfillstyle(1,0); setcolor(0);
        fillellipse(x+90,y+25,29,39);
        fbar(x+61,y+5,x+70,y+25,0);
        fbar(x+85,y+10,x+135,y+64,0);}

        setfillstyle(1,dc[0]);
        setcolor(dc[0]);
        fbar(x,y-85,x+60,y-40,dc[0]);
        fillellipse(x+60,y-40,60,40);
        fbar(x+60,y-20,x+138,y,dc[0]);
        setfillstyle(1,0); setcolor(0);
        fillellipse(x+90,y-60,29,39);
        fbar(x+61,y-80,x+70,y-60,0);
        fbar(x+85,y-75,x+135,y-21,0);
  end else begin
        {upper-left border}
        setfillstyle(1,dc[0]);
        setcolor(dc[0]);
        fbar(x,y+85,x+60,y+40,dc[0]);
        fillellipse(x+60,y+40,60,40);
        fbar(x+60,y+20,x+138,y,dc[0]);
        setfillstyle(1,0); setcolor(0);
        fillellipse(x+90,y+60,29,39);
        fbar(x+61,y+80,x+70,y+60,0);
        fbar(x+85,y+75,x+135,y+21,0);
  end;
end;

procedure setscreen(display:integer);
var
 i,j,k,l:integer;
 s:string;
begin
 fade_out;
 cleardevice;

 for i:=0 to 63 do
  begin
   color[128+i]:=color[0];
   fade_pal[128+i]:=color[0];
  end;

 if color_changing then
    choose_colors;


 case display of
   01:begin
        setfillstyle(1,dc[0]); setcolor(dc[0]);

        {top/left border}
        fillellipse(45,45,40,40);
        bar(5,45,65,97);
        bar(5,441,65,475);
        bar(45,5,635,40);
        fbar(66,41,85,85,0);
        button_plain(5,100,60,20,rand_label,rand_box(0,1));
        button_plain(5,143,60,30,rand_label,rand_box(0,1));
        button_plain(5,206,60,10,rand_label,rand_box(0,1));
        button_plain(5,229,60,20,rand_label,rand_box(0,1));
        button_plain(5,272,60,30,rand_label,rand_box(0,1));
        button_plain(5,335,60,20,rand_label,rand_box(0,1));
        button_plain(5,378,60,30,rand_label,rand_box(0,1));

        {top row buttons}
        button_cboth(75,45,120,8,'MODE SELECT',dc[3]);
        button_cright(580,45,46,8,'NEXT',dc[3]);
        button_cleft(520,45,46,8,'PREV',dc[3]);
        button_dboth(230,45,120,8,'LCARS ACCESS',dc[3],3);

        {bottom row buttons}
        button_dboth(75,459,120,8,'DIAGNOSTICS',dc[3],3);
        button_dright(580,459,46,8,'FIRST',dc[3],3);
        button_dleft(520,459,46,8,'LAST',dc[3],3);
        button_cboth(410,459,82,8,'RESTART',dc[3]);
        button_cboth(230,459,120,8,'SYSTEM SELECT',dc[3]);

        {mid-panel divider}
        button_plain(068,206,52,10,rand_label,rand_box(0,1));
        button_plain(123,206,70,10,rand_label,rand_box(0,1));
        button_plain(196,206,60,10,rand_label,rand_box(0,1));
        button_plain(259,206,88,10,rand_label,rand_box(0,1));
        fbar(350,176,400,256,dc[0]);
        setfillstyle(1,0);
        fillellipse(350,176,30,29);
        fillellipse(350,256,30,29);
        fbar(381,259,400,475,dc[0]);
        fbar(381,43,400,173,dc[0]);
        fbar(381,43,427,63,dc[0]);
        button_plain(430,43,80,10,rand_label,rand_box(0,1));
        fbar(381,43,410,73,dc[0]);
        setfillstyle(1,0);
        fillellipse(410,73,9,9);


        {upper-left window}
        button_dleft(75,080,30,8,cstr(dc[0]),dc[0],3);
        button_dleft(75,105,30,8,cstr(dc[1]),dc[1],3);
        button_dleft(75,130,30,8,cstr(dc[2]),dc[2],3);
        button_dleft(75,155,30,8,cstr(dc[3]),dc[3],3);
        button_cright(120,080,240,8,'LIBRARY COMPUTER',rand_col(2,3));
        button_cright(120,105,240,8,'PERSONAL LOGS',rand_col(2,3));
        button_cright(120,130,240,8,'MISSION LOGS',rand_col(2,3));
        button_cright(120,155,240,8,'SENSOR LOGS',rand_col(2,3));
        button_cboth(75,180,50,7,'Exit',rand_col(2,3));
        button_cboth(145,180,50,7,'Halt',rand_col(2,3));
        button_cboth(215,180,50,7,'New',rand_col(2,3));
        button_cboth(285,180,50,7,'Undo',rand_col(2,3));

        {lower-left window}
        for k:=0 to 3 do
         for i:=0 to 3 do
          button_cboth(075+i*75,250+k*30,52,9,rand_label,rand_col(1,3));
        for k:=0 to 5 do
         for i:=0 to 3 do
          flashy_number(75+i*75,375+k*12);

        {right-side window}
        for i:=0 to 10 do
         begin
          button_dleft (420,080+i*25,55,8,rand_label,rand_col(2,3),3);
          button_plain (488,080+i*25,55,8,rand_label,rand_col(2,3));
          fbar(548,080+i*25,556,096+i*25,dc[random(3)+1]);
          button_cright(560,080+i*25,55,8,rand_label,rand_col(2,3));
         end;
        fbar(513,365,525,441,dc[0]);
        button_dleft(420,365,80,8,'LIBRARY',rand_col(2,3),3);
        button_dleft(420,395,80,8,'DATABANK',rand_col(2,3),3);
        button_dleft(420,425,80,8,'DATABASE',rand_col(2,3),3);
        button_dright(530,365,80,8,'STORAGE',rand_col(2,3),3);
        button_dright(530,395,80,8,'DELETED',rand_col(2,3),3);
        button_dright(530,425,80,8,'PENDING',rand_col(2,3),3);

        if random(2)=0 then
         begin
          fbar(66,11,290,40,0);
          imagexy(68,12,title[1],dc[0]);
         end else begin
          fbar(414,7,635,37,0);
          imagexy(416,7,title[1],dc[0]);
         end;
      end;

   02:begin
        corner_curve(5,145,false);
        corner_curve(5,140,true);

        fbar(5,5,65,12,dc[0]);
        button_plain(5,15,60,8,rand_label,rand_box(0,1));
        button_plain(5,34,60,8,rand_label,rand_box(0,1));
        fbar(5,53,65,100,dc[0]);
        fbar(5,221,65,280,0);
        button_plain(5,223,60,8,rand_label,rand_box(0,1));
        button_plain(5,242,60,8,rand_label,rand_box(0,1));
        button_plain(5,261,60,30,rand_label,rand_box(0,1));
        button_plain(5,324,60,30,rand_label,rand_box(0,1));
        button_plain(5,387,60,8,rand_label,rand_box(0,1));
        button_plain(5,406,60,8,rand_label,rand_box(0,1));
        fbar(5,425,65,475,dc[0]);

        {middle border}
        for k:=0 to 1 do
         for i:=0 to 5 do
          button_plain(146+i*82,120+k*25,79,10,rand_label,rand_box(0,1));

        {upper window}
        for k:=0 to 8 do
         for i:=0 to 6 do
          flashy_number(95+i*75,5+k*12);

        {right-side button-bar}
        button_cleft(510,180,115,10,'ASTROMETRICS',dc[random(2)+2]);
        button_cleft(510,205,115,10,'ALIEN SPECIES',dc[random(2)+2]);
        button_cleft(510,230,115,10,'COSMOLOGY',dc[random(2)+2]);
        button_cleft(510,255,115,10,'QUANTUM THEORY',dc[random(2)+2]);
        button_cleft(510,280,115,10,'STARSHIPS',dc[random(2)+2]);
        button_cleft(510,305,115,10,'HISTORY',dc[random(2)+2]);
        button_cleft(510,330,115,10,'TECHNOLOGY',dc[random(2)+2]);
        button_cleft(510,355,115,10,'WARP THEORY',dc[random(2)+2]);
        button_cleft(510,380,115,10,'FEDERATION',dc[random(2)+2]);
        button_cleft(510,405,115,10,'PLANETS',dc[random(2)+2]);
        button_cleft(510,430,115,10,'SCHEMATICS',dc[random(2)+2]);
        button_cleft(510,455,115,10,'WEAPONS',dc[random(2)+2]);

        {bottom-window}
        button_dright(200,459,50,8,'NEXT',dc[3],3);
        fbar(191,459,197,475,dc[3]);
        button_dleft(130,459,50,8,'PREV',dc[3],3);
        button_dboth(300,459,140,8,'DATA INDEX',dc[3],3);
        for i:=0 to 13 do
         button_dright(70,201+i*20,10,7,'',rand_col(0,3),3);
      end;

   03:begin
        corner_curve(5,345,false);
        corner_curve(5,340,true);

        {left-side buttons}
        fbar(5,426,65,446,0);
        fbar(5,150,65,212,dc[0]);
        button_plain(5,215,60,8,rand_label,rand_box(0,1));
        button_plain(5,234,60,8,rand_label,rand_box(0,1));
        fbar(5,253,65,300,dc[0]);
        fbar(5,5,65,31,dc[0]);
        button_plain(5,034,60,8,rand_label,rand_box(0,1));
        button_plain(5,053,60,28,rand_label,rand_box(0,1));
        button_plain(5,112,60,8,rand_label,rand_box(0,1));
        button_plain(5,131,60,8,rand_label,rand_box(0,1));
        fbar(5,465,65,475,dc[0]);
        button_plain(5,428,60,8,rand_label,rand_box(0,1));
        button_plain(5,446,60,8,rand_label,rand_box(0,1));

        {middle border}
        for k:=0 to 1 do
         for i:=0 to 5 do
          button_plain(146+i*82,320+k*25,79,10,rand_label,rand_box(0,1));

        {lower window}
        for k:=0 to 8 do
         for i:=0 to 6 do
          flashy_number(95+i*75,372+k*12);

        {upper bar}
        fbar(368,5,399,31,dc[0]);
        imagexy(402,4,title[0],dc[0]);
        for i:=0 to 4 do
          button_plain(68+i*60,5,57,13,rand_label,rand_box(0,1));

        {upper window}
        button_cboth(080,40,160,8,'PRIMARY SUB-SYSTEM',dc[3]);
        button_cboth(280,40,095,8,'MONITOR',dc[3]);
        button_cboth(400,40,095,8,'ANALYZE',dc[3]);
        button_cboth(520,40,095,8,'DIAGNOSTIC',dc[3]);

        fbar(210,085,150,095,dc[2]);
        fbar(210,125,150,135,dc[2]);
        fbar(210,165,150,175,dc[2]);
        fbar(500,085,530,095,dc[2]);
        fbar(500,125,530,135,dc[2]);
        fbar(500,165,530,175,dc[2]);
        fbar(210,245,150,255,dc[2]);
        fbar(210,285,150,295,dc[2]);

        for i:=90 to 285 do
         begin
          setcolor((i mod 12)+144);
          line(260,i,300,i);
         end;

        for i:=285 downto 90 do
         begin
          setcolor((11-(i mod 12))+144);
          line(385,i,405,i);
          if i>130 then
             line(415,i,435,i);
          if i>170 then
             line(445,i,465,i);
         end;


        button_dleft(100,080,090,10,'NOMINAL',rand_col(2,3),3);
        button_plain(210,080,140,10,'PRIMARY REACTOR',dc[2]);
        button_dleft(100,120,090,10,'NOMINAL',rand_col(2,3),3);
        button_plain(210,120,140,10,'SECONDARY POWER',dc[2]);
        button_dleft(100,160,090,10,'NOMINAL',rand_col(2,3),3);
        button_plain(210,160,140,10,'AUX POWER UNIT',dc[2]);

        button_dleft(100,240,090,10,'NOMINAL',rand_col(2,3),3);
        button_plain(210,240,260,10,'PRIMARY POWER DISTRIBUTION HUB',dc[2]);
        button_dleft(100,280,090,10,'NOMINAL',rand_col(2,3),3);
        button_plain(210,280,260,10,'REDUNDANT DISTRIBUTION HUB',dc[2]);

        button_dright(530,080,090,10,'NOMINAL',rand_col(2,3),3);
        button_plain(380,080,140,10,'LIFE SUPPORT',dc[2]);
        button_dright(530,120,090,10,'NOMINAL',rand_col(2,3),3);
        button_plain(410,120,110,10,'PROPULSION',dc[2]);
        button_dright(530,160,090,10,'NOMINAL',rand_col(2,3),3);
        button_plain(440,160,080,10,'COMPUTER',dc[2]);

        button_cboth(515,210,100,8,'FAILURE SIM.',rand_flash(0,3));
        button_cboth(515,235,100,8,'WARNING',rand_flash(0,3));
        button_cboth(515,260,100,8,'OVERHEAT',rand_flash(0,3));
        button_cboth(515,285,100,8,'OVERLOAD',rand_flash(0,3));
      end;

   04:begin
        {top/left border}
        setfillstyle(1,dc[0]); setcolor(dc[0]);
        fillellipse(45,45,40,40);
        bar(5,45,65,97);
        bar(5,441,65,475);
        bar(45,5,100,40);
        bar(45,5,635,13);
        bar(607,5,635,40);
        fbar(66,41,85,85,0);
        button_plain(5,100,60,20,rand_label,rand_box(0,1));
        button_plain(5,143,60,30,rand_label,rand_box(0,1));
        button_plain(5,206,60,10,rand_label,rand_box(0,1));
        button_plain(5,229,60,20,rand_label,rand_box(0,1));
        button_plain(5,272,60,30,rand_label,rand_box(0,1));
        button_plain(5,335,60,20,rand_label,rand_box(0,1));
        button_plain(5,378,60,30,rand_label,rand_box(0,1));
        for i:=0 to 7 do
         button_plain(103+i*63,16,60,12,rand_label,rand_box(0,1));

        {picture and frame}
        setfillstyle(1,dc[0]); setcolor(dc[0]);
        fillellipse(475,330,20,20);
        fbar(68,43,475,350,dc[0]);
        fbar(68,43,495,330,dc[0]);
        case random(3) of
         1:s:=main_filename+'.I01';
         2:s:=main_filename+'.I02';
         else s:=main_filename+'.I03';
        end;
        display_rawpanel(80,60,s);

        {lower window}
        for k:=0 to 9 do
         for i:=0 to 4 do
          flashy_number(95+i*75,360+k*12);

        {right-side button-bar}
        for i:=0 to 16 do
         begin
          button_cleft (505,55+i*25,50,10,rand_label,rand_col(2,3));
          button_cright(575,55+i*25,50,10,rand_label,rand_col(2,3));
         end;

      end;

   05:begin
        corner_curve(5,5,false);
        corner_curve(5,240,true);
        corner_curve(5,245,false);
        corner_curve(5,475,true);

        {left side buttons}
        fbar(5,321,65,405,0);
        fbar(5,081,65,165,0);
        button_plain(5,083,60,12,rand_label,rand_box(0,1));
        button_plain(5,110,60,13,rand_label,rand_box(0,1));
        button_plain(5,139,60,12,rand_label,rand_box(0,1));
        button_plain(5,323,60,12,rand_label,rand_box(0,1));
        button_plain(5,350,60,13,rand_label,rand_box(0,1));
        button_plain(5,379,60,12,rand_label,rand_box(0,1));

        {mid borders}
        for i:=0 to 5 do
         begin
          for k:=0 to 1 do
           button_plain(146+i*82,220+k*25,79,10,rand_label,rand_box(0,1));
          for k:=0 to 1 do
           button_plain(146+i*82,5+k*450,79,10,rand_label,rand_box(0,1));
         end;

        {upper window}
        for k:=0 to 13 do
         for i:=0 to 2 do
          flashy_number(443+i*75,40+k*12);

        {lower window}
        setfillstyle(1,dc[3]);
        setcolor(dc[3]);
        fillellipse(158,360,50,50);
        setcolor(0);
        for i:=0 to 2 do
         line(157+i,310,157+i,410);
        for i:=0 to 2 do
         line(108,359+i,208,359+i);

        button_dleft(80,280,66,10,'FORE',dc[3],3);
        button_dright(160,280,65,10,'AFT',dc[3],3);
        button_dleft(80,420,51,10,'PORT',dc[3],3);
        button_dright(145,420,80,10,'STARBOARD',dc[3],3);

        button_cboth(260,280,100,10,'ACCELERATION',rand_col(2,3));
        button_cboth(260,308,100,10,'VELOCITY',rand_col(2,3));
        button_cboth(260,336,100,10,'NAVIGATION',rand_col(2,3));
        button_cboth(260,364,100,10,'PLOT COURSE',rand_col(2,3));
        button_cboth(260,392,100,10,'STAR CHARTS',rand_col(2,3));
        button_cboth(260,420,100,10,'POSITION',rand_col(2,3));

        for i:=0 to 2 do
         for k:=0 to 5 do
          button_dleft(405+i*80,280+k*28,60,10,rand_label,rand_col(2,3),2);
      end;
   06:begin
        corner_curve(5,5,false);
        corner_curve(5,475,true);

        {left side buttons}
        fbar(5,321,65,405,0);
        fbar(5,081,65,165,0);
        button_plain(5,083,60,12,rand_label,rand_box(0,1));
        button_plain(5,110,60,12,rand_label,rand_box(0,1));
        button_plain(5,137,60,12,rand_label,rand_box(0,1));
        button_plain(5,164,60,20,rand_label,rand_box(0,1));
        button_plain(5,207,60,11,rand_label,rand_box(0,1));
        button_plain(5,232,60,11,rand_label,rand_box(0,1));
        button_plain(5,257,60,11,rand_label,rand_box(0,1));
        button_plain(5,282,60,20,rand_label,rand_box(0,1));
        button_plain(5,325,60,12,rand_label,rand_box(0,1));
        button_plain(5,352,60,12,rand_label,rand_box(0,1));
        button_plain(5,379,60,12,rand_label,rand_box(0,1));

        {mid border}
        fbar(5,207,200,229,dc[0]);
        for i:=0 to 3 do
          button_plain(203+i*63,207,60,11,rand_label,rand_box(0,1));
        setfillstyle(1,dc[0]); setcolor(dc[0]);
        fbar(455,207,510,229,dc[0]);
        fbar(515,250,545,452,dc[0]);
        fillellipse(510,250,35,43);
        setfillstyle(1,0); setcolor(0);
        fillellipse(494,250,20,20);
        fbar(455,230,494,240,0);
        fbar(455,250,514,300,0);

        {upper/lower borders}
        for i:=0 to 5 do
          for k:=0 to 1 do
           button_plain(146+i*82,5+k*450,79,10,rand_label,rand_box(0,1));

        {right-side tabs}
        for i:=0 to 15 do
         button_dleft(560,40+(i*25),66,10,rand_label,rand_col(2,3),3);

        {lower window}
        button_cboth(075,235,100,10,'DATA ENTRY',rand_col(2,3));
        button_cboth(205,235,90,10,'DOWNLINK',rand_col(2,3));
        button_cboth(325,235,80,10,'UPLINK',rand_col(2,3));
        button_cboth(435,235,50,10,'SCAN',rand_col(2,3));
        for i:=0 to 6 do
         begin
          button_dleft(090,275+i*25,65,8,rand_label,rand_col(2,3),3);
          button_plain(166,275+i*25,40,8,hex(random(65535)),rand_col(2,3));
          button_plain(209,275+i*25,40,8,hex(random(65535)),rand_col(2,3));
          button_cright(252,275+i*25,65,8,rand_label,rand_col(2,3));
          button_dleft(345,275+i*25,60,8,rand_label,rand_col(2,3),3);
          button_cright(416,275+i*25,60,8,rand_label,rand_col(2,3));
         end;

        {upper window}
        k:=random(2);
        fbar(80,40,440,185,dc[k]);
        fbar(80,40,90,50,0);
        fbar(430,40,440,50,0);
        fbar(80,175,90,185,0);
        fbar(430,175,440,185,0);
        setfillstyle(1,dc[k]); setcolor(dc[k]);
        fillellipse(90,50,10,10);
        fillellipse(430,50,10,10);
        fillellipse(90,175,10,10);
        fillellipse(430,175,10,10);
        fbar(90,50,430,175,0);

        fbar(84,192,436,201,dc[k]);
        myellipse(84,196,4,4,dc[k]);
        myellipse(84,197,4,4,dc[k]);
        myellipse(436,196,4,4,dc[k]);
        myellipse(436,197,4,4,dc[k]);
        j:=random(2)+2;
        for i:=0 to 11 do
         fbar(86+i*29,195,114+i*29,198,128+j*16+i);
        fbar(84,192,85,201,dc[k]);
        fbar(435,192,436,201,dc[k]);


        button_cright(445,040,90,10,'ENHANCE',rand_col(2,3));
        button_cright(445,065,90,10,'ROTATE',rand_col(2,3));
        button_cright(445,090,90,10,'ZOOM',rand_col(2,3));
        button_cright(445,115,90,10,'RESOLVE',rand_col(2,3));
        button_cright(445,140,90,10,'SCAN',rand_col(2,3));
        button_cright(445,165,90,10,'HISTOGRAM',rand_col(2,3));

        for i:=0 to 127 do
         begin
          starx[i]:=random(340)+90;
          stary[i]:=random(125)+50;
          starc[i]:=random(12)+20;
          stars[i]:=(starc[i] shr 2);
          putpixel(starx[i],stary[i],starc[i]);
         end;

      end;
   07:begin
        corner_curve(5,5,false);
        corner_curve(5,240,true);
        corner_curve(5,245,false);
        corner_curve(5,475,true);

        {left side buttons}
        fbar(5,321,65,405,0);
        fbar(5,081,65,165,0);
        button_plain(5,083,60,12,rand_label,rand_box(0,1));
        button_plain(5,110,60,13,rand_label,rand_box(0,1));
        button_plain(5,139,60,12,rand_label,rand_box(0,1));
        button_plain(5,323,60,12,rand_label,rand_box(0,1));
        button_plain(5,350,60,13,rand_label,rand_box(0,1));
        button_plain(5,379,60,12,rand_label,rand_box(0,1));

        {mid borders}
        for i:=0 to 5 do
         begin
          for k:=0 to 1 do
           button_plain(146+i*82,220+k*25,79,10,rand_label,rand_box(0,1));
          for k:=0 to 1 do
           button_plain(146+i*82,5+k*450,79,10,rand_label,rand_box(0,1));
         end;

        {lower window}
        k:=random(2);
        fbar(80,280,440,440,dc[k]);
        fbar(80,280,90,290,0);
        fbar(430,280,440,290,0);
        fbar(80,430,90,440,0);
        fbar(430,430,440,440,0);
        setfillstyle(1,dc[k]); setcolor(dc[k]);
        fillellipse(90,290,10,10);
        fillellipse(430,290,10,10);
        fillellipse(90,430,10,10);
        fillellipse(430,430,10,10);
        fbar(90,290,430,430,0);

        {upper window}
        button_dleft(90,40,2,10,'',dc[3],3);
        button_plain(104,40,85,10,'ENHANCE',rand_col(2,3));
        fbar(193,40,280,206,dc[3]);
        setfillstyle(1,0); setcolor(0);
        fillellipse(193,120,57,59);
        fbar(193,120,250,206,0);
        setfillstyle(1,dc[2]); setcolor(dc[2]);
        fillellipse(170,130,50,50);
        setcolor(0);
        setlinestyle(0,0,3);
        line(130,90,210,170);
        line(210,90,130,170);
        setlinestyle(0,0,1);
        textxy(167,112,'+',0,dc[2]);
        textxy(167,147,'-',0,dc[2]);
        textxy(125,127,'PT',0,dc[2]);
        textxy(202,127,'SB',0,dc[2]);
        button_cboth(104,190,20,8,'<<',rand_col(3,3));
        button_cboth(200,190,20,8,'>>',rand_col(3,3));

        button_dright(283,040,100,8,'NEBULAE',rand_col(2,3),3);
        button_dright(283,065,100,8,'STARS',rand_col(2,3),3);
        button_dright(283,090,100,8,'BLACK HOLES',rand_col(2,3),3);
        button_dright(283,115,100,8,'PLANETS',rand_col(2,3),3);
        button_dright(283,140,100,8,'ASTEROIDS',rand_col(2,3),3);
        button_dright(283,165,100,8,'MOONS',rand_col(2,3),3);
        button_dright(283,190,100,8,'GALAXIES',rand_col(2,3),3);

        for i:=0 to 6 do
         begin
          button_cleft (410,40+25*i,50,8,rand_label,rand_col(1,3));
          button_cright(471,40+25*i,50,8,rand_label,rand_col(1,3));
          button_cboth (548,40+25*i,70,8,rand_label,rand_col(1,3));
         end;

      end;

 end;
 cycle:=0;
 fade_in;
end;


procedure wait_check;
var
 c:char;
 s:tinystring;
 i,j,k:integer;
begin
  update_palette;
  c:=#255;
  if timing then
    repeat until main_timer<>mem[0:$46C]; main_timer:=mem[0:$46C];
  inc(cycle);
  if autorotate and (cycle>update_time) then skip:=true;
  if keypressed then
   begin
    c:=readkey; flushkey;
    case c of
      #27,'q','Q':quit:=true;
      #32,#13:skip:=true;
      '1'..'7':begin
                current_display:=value(c);
                setscreen(current_display);
               end;
      'a','A':begin
               autorotate:=not autorotate;
               if autorotate then s:='ON'
                             else s:='OFF';
               show_status('Auto-Rotate: '+s);
              end;
      'c','C':begin
               color_changing:=not color_changing;
               if color_changing then s:='ON'
                             else s:='OFF';
               show_status('Color Changing: '+s);
              end;
      '+','=':begin
               inc(update_time,182);
               if update_time>182*60 then update_time:=182*60;
               i:=round(update_time/18.2);
               j:=i mod 60; k:=i div 60;
               show_status('Display Time: '+cstr(k)+' min '+cstr(j)+' sec');
              end;
      '-','_':begin
               dec(update_time,182);
               if update_time<182 then update_time:=182;
               i:=round(update_time/18.2);
               j:=i mod 60; k:=i div 60;
               show_status('Display Time: '+cstr(k)+' min '+cstr(j)+' sec');
              end;
      'm','M':begin
               show_status('DOS-Memory Free: '+cstr(memavail)+' bytes');
              end;
      #8:begin
          save_raw(mypath+main_filename+'.RAW');
          show_status('Screenshot saved as '+main_filename+'.RAW');
         end;
    end;
   end;
end;


procedure update_display(display:integer);
var
 i,j,k,l,cyc,c,co:integer;
 r,ro:real;
 s:string;
begin
 case display of
   01:begin
       {randomize a number}
       flashy_number(75+random(4)*75,375+random(6)*12);
       {randomize a button}
       if random(5)=0 then
        begin
         k:=random(4);
         i:=random(4);
         button_cboth(075+i*75,250+k*30,52,9,rand_label,rand_col(1,3));
        end;
      end;
   02:begin
       flashy_number(95+random(6)*75,5+random(8)*12);
       if (cycle shr 3) <> last_cycle then
        begin
         last_cycle:=cycle shr 3;

         for i:=0 to 27 do
          begin
           k:=(i+last_cycle) mod essay_length;
           textxy(120,175+i*10,essay[k],dc[2],0);
          end;

        end;

      end;
   03:begin
       flashy_number(95+random(6)*75,372+random(8)*12);
      end;
   04:begin
       flashy_number(95+random(5)*75,360+random(10)*12);
       if random(10)=0 then
        begin
         if random(2)=0 then
          button_cleft (505,55+random(17)*25,50,10,rand_label,rand_col(2,3))
         else
          button_cright(575,55+random(17)*25,50,10,rand_label,rand_col(2,3));
        end;
      end;
   05:begin
       flashy_number(443+random(3)*75,40+random(14)*12);
{       if (cycle shr 2) <> last_cycle then
        begin
         last_cycle:=cycle shr 2;

         for i:=0 to 16 do
          begin
           k:=(i+last_cycle) mod essay_length;
           textxy(85,40+i*10,essay[k],dc[2],0);
          end;

        end;}
       k:=cycle mod essay_length;
       if (cycle and 31)<=16 then
        begin
         textxy(85,40+(cycle and 31)*10,essay[k],dc[2],0);
        end;
       {if (cycle and 31)=31 then
        fbar(85,40,430,210,0);}
       if random(10)=0 then
        button_dleft(405+random(3)*80,280+random(6)*28,60,10,rand_label,rand_col(2,3),2);
      end;
   06:begin
       {flashy_number(80+random(6)*75,190);}
       if random(20)=0 then
         button_dleft(560,40+(random(16)*25),66,10,rand_label,rand_col(2,3),3);
       if random(10)=0 then
        case random(6) of
          0:button_dleft(090,275+random(7)*25,65,8,rand_label,rand_col(2,3),3);
          1:button_plain(166,275+random(7)*25,40,8,hex(random(65535)),rand_col(2,3));
          2:button_plain(209,275+random(7)*25,40,8,hex(random(65535)),rand_col(2,3));
          3:button_cright(252,275+random(7)*25,65,8,rand_label,rand_col(2,3));
          4:button_dleft(345,275+random(7)*25,60,8,rand_label,rand_col(2,3),3);
          5:button_cright(416,275+random(7)*25,60,8,rand_label,rand_col(2,3));
        end;
       for i:=0 to 127 do
        begin
         putpixel(starx[i],stary[i],0);
         inc(starx[i],stars[i]);
         if starx[i]>430 then begin dec(starx[i],340); stary[i]:=random(125)+50; end;
         putpixel(starx[i],stary[i],starc[i]);
        end;
      end;
   07:begin
       k:=random(4)+1;
       s:='';
       for i:=1 to k do
        s:=s+' '+hex(random(65535));
       textxy(460,282+(cycle and 15)*10,addfront(s,20),dc[2],0);
       cyc:=cycle and 127;
       case cyc of
         1:begin
            fbar(90,290,430,430,97);
            setcolor(38);
            setlinestyle(1,0,1);
            for i:=0 to 7 do
             line(120+i*40,290,120+i*40,430);
            for i:=0 to 4 do
             line(90,300+i*30,430,300+i*30);
            setlinestyle(0,0,1);
            for i:=0 to 4 do
             begin
              freq[i]:=random(10)+1;
              amp[i]:=random(16)+5;
              phase[i]:=(random(1024)/1024)*pi*2;
             end;
           end;
         2..41:begin
                c:=cyc-2;
                setfillstyle(1,dc[3]);
                setcolor(dc[3]);
                r:=0;
                for i:=0 to 4 do
                 begin
                  r:=r+sin(phase[i]+(c/40*pi)*(freq[i]*0.66))*(amp[i]/10);
                 end;
                fillellipse(100+c*8,360+round(r*6)+random(17)-8,2,2);
               end;
         61..99:begin
                c:=cyc-60;
                co:=c-1;
                setcolor(dc[2]);
                r:=0; ro:=0;
                for i:=0 to 4 do
                 begin
                  ro:=ro+sin(phase[i]+(co/40*pi)*(freq[i]*0.66))*(amp[i]/10);
                  r:=r+sin(phase[i]+(c/40*pi)*(freq[i]*0.66))*(amp[i]/10);
                 end;
                setlinestyle(0,0,3);
                line(100+co*8,360+round(ro*6),
                     100+c*8,360+round(r*6));
                setlinestyle(0,0,1);
               end;
       end;
       if random(20)=0 then
        begin
         case random(3) of
          0:button_cleft (410,40+25*random(7),50,8,rand_label,rand_col(1,3));
          1:button_cright(471,40+25*random(7),50,8,rand_label,rand_col(1,3));
          2:button_cboth (548,40+25*random(7),70,8,rand_label,rand_col(1,3));
         end;
        end;
      end;
 end;
end;


procedure game;
var
 old_display:integer;
begin
 quit:=false; skip:=false;
 current_display:=start_display;
 if current_display>0 then
    setscreen(current_display);
 repeat
  if skip or (current_display=0) then
   begin
     old_display:=current_display;
     repeat
       current_display:=random(max_displays)+1;
     until current_display<>old_display;
     if current_display>max_displays then current_display:=max_displays;
     setscreen(current_display);
     skip:=false;
   end;
  update_display(current_display);
  wait_check;
 until quit;
 flushkey;
end;

procedure main;
begin
 game;
end;


begin
 init;
 main;
 shutdown;
end.



